/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analyzer/dart/ast/ast.dart';
import 'package:build/build.dart';
import 'package:welltested/src/visitors/class_visitor.dart';

import '../utilities/utilities.dart';

class AstElementExecutor {
  Future<Map<String, MethodDeclaration>> methodNodesFromClassVisitor(
      BuildStep buildStep, ClassVisitor classVisitor) async {
    final Map<String, MethodDeclaration> methodAstNodes = {};
    for (final method in classVisitor.methods.entries) {
      final node = (await getResolvedAstNodeForElement(method.value, buildStep))
          as MethodDeclaration;
      methodAstNodes[method.key] = node;
    }
    return methodAstNodes;
  }
}
