/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:source_gen/source_gen.dart';
import 'package:welltested/annotation.dart';

extension Values on ConstantReader {
  List<String> get excludeMethods => read('excludedMethods')
      .listValue
      .map((e) => e.toStringValue() ?? "")
      .toList();

  List<ScreenType> get screenTypes {
    final _rawScreenTypes = read('screenTypes').listValue;
    final List<ScreenType> screenTypes = [];
    for (final type in _rawScreenTypes) {
      final name = type.getField("_name")?.toStringValue();
      if (name != null) {
        screenTypes.add(ScreenType.values.firstWhere((t) => t.name == name));
      }
    }
    return screenTypes;
  }
}
