/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analysis_server_lib/analysis_server_lib.dart';
import 'package:welltested/src/visitors/unit_test_visitor.dart';

extension ReplaceList on List<ReplaceModel> {
  List<ReplaceModel> get extractUniqueAndUnoverlapped {
    final List<ReplaceModel> uniqueModels = [];
    this.forEach((element) {
      if (uniqueModels.indexWhere((unique) =>
              element.offset == unique.offset &&
              element.endOffset == unique.endOffset) ==
          -1) {
        uniqueModels.add(element);
      }
    });
    uniqueModels.removeWhere((element) {
      for (int i = 0; i < uniqueModels.length; i++) {
        if (element.offset > uniqueModels[i].offset &&
            element.endOffset < uniqueModels[i].endOffset) {
          return true;
        }
      }
      return false;
    });
    return uniqueModels;
  }
}

extension SourceEditSequence on List<SourceEdit> {
  List<SourceEdit> get filterDuplicationReplacements {
    final List<SourceEdit> filteredList = [];
    forEach((edit) {
      if (filteredList.indexWhere(
              (element) => element.replacement == edit.replacement) ==
          -1) {
        filteredList.add(edit);
      }
    });
    return filteredList;
  }
}
