/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'dart:convert';

import 'package:analyzer/dart/ast/ast.dart';
import 'package:analyzer/dart/element/type.dart';
import 'package:welltested/annotation.dart';
import 'package:welltested/src/extensions/screen_type_extension.dart';

class WidgetTestRequestData {
  final DartType classType;
  final Uri fileImportPath;
  List<AstNode> widgets;
  final bool isStatefulWidget;
  final List<ScreenType> screenTypes;
  WidgetTestRequestData(
      {required this.classType,
      required this.fileImportPath,
      required this.widgets,
      required this.screenTypes,
      this.isStatefulWidget = false});
  String get className => classType.getDisplayString(withNullability: false);

  String get codeInScrutity {
    String code = '';
    widgets.forEach((widget) {
      code = code + widget.toSource();
    });
    return code;
  }

  Map<String, dynamic> toJson() => {
        "class_name": className,
        "code": codeInScrutity,
        "file_import_path": fileImportPath.toString(),
        "is_stateful_widget": isStatefulWidget.toString(),
        'test_screens':
            jsonEncode(screenTypes.map((e) => e.valueString).toList())
      };
}
