/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'dart:io';

import 'package:build/build.dart';

class PathRepository {
  String relativeTestDirectory(AssetId assetId) {
    return assetId.path.replaceAll("lib", "test").replaceAll(".dart", '');
  }

  String relativeIntegrationTestDirectory(AssetId assetId) {
    return assetId.path.replaceAll(".dart", '');
  }

  String correspondingTemporaryUnitFile(int i, AssetId assetId) {
    return "${relativeTestDirectory(assetId)}/$i.wt.dart";
  }

  Future<File?> correspondingPermanentTestFile(
      String functionName, AssetId assetId) async {
    final path =
        "${Directory.current.path}/${relativeTestDirectory(assetId)}/$functionName.welltested_test.dart";
    return (await File(path).exists()) ? File(path) : null;
  }
}
