/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'dart:io';

import 'package:build/build.dart';

class WriterRepository {
  WriterRepository(this.buildStep);
  final BuildStep buildStep;

  Future<File> writeTestToCorrespondingFile(
      AssetId assetId, String testContent, String methodName) async {
    final path = assetId.path;
    final filePath = path.replaceFirst(path.split("/").first, "");
    final outputFile = File(
        "${Directory.current.path}${Platform.pathSeparator}test${filePath.replaceAll("/", Platform.pathSeparator)}"
            .replaceFirst(".dart", "_${methodName.toLowerCase()}_test.dart"));
    if (!await outputFile.exists()) {
      await outputFile.create(recursive: true);
    }
    return await outputFile.writeAsString(testContent);
  }

  Future<void> outputGeneratedFile(
    AssetId assetId,
    String content,
    String functionIdentifier,
  ) async {
    await buildStep.writeAsString(
        assetId, addFunctionIdentiferAtTop(content, functionIdentifier));
  }

  String addFunctionIdentiferAtTop(String content, String functionIdentifier) {
    return content.replaceRange(0, 0, "///###$functionIdentifier###" + '\n');
  }
}
