/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analyzer/dart/ast/ast.dart';
import 'package:analyzer/dart/element/element.dart';
import 'package:build/build.dart';

/// Read [https://github.com/dart-lang/build/issues/2689]('InconsistentAnalysisException: Requested result might be inconsistent with previously returned results')
Future<AstNode> getResolvedAstNodeForElement(
    Element element, BuildStep buildStep) async {
  final astNode = await buildStep.resolver.astNodeFor(element, resolve: true);
  if (astNode == null) throw ("Node of this element is null");
  return astNode;
}

bool isPrivate(String name) {
  return name.startsWith("_");
}
